
#define SORTIE 11
#define NE 100 // nombre d'échantillons du signal

uint32_t icr;
uint32_t period;
float echant[NE]; // tableau contenant les échantillons du signal
uint32_t periode_echant;
uint16_t indice;

//Initialisation du Timer1 pour génération MLI
void init_pwm_timer1(uint32_t period) { // période en microsecondes
  uint16_t diviseur[6] = {0,1,8,64,256,1024};
  TCCR1A = (1 << COM1A1); //Clear OC1A on compare match when upcounting, set OC1A on compare match when downcounting
  TCCR1B = 1 << WGM13; // phase and frequency correct pwm mode, top = ICR1
  int d=1;
  icr = (F_CPU/1000000*period/2);
  while ((icr>0xFFFF)&&(d<6)) { // choix du diviseur d'horloge
     d++;
     icr = (F_CPU/1000000*period/2/diviseur[d]);
  }
  Serial.print("diviseur_1= "); Serial.println(d);
  Serial.print("icr_1 = "); Serial.println(icr);
  float periode_effective = icr*2*d*1000000.0/F_CPU;
  Serial.print("periode_1 (us) = "); Serial.println(periode_effective);
  ICR1 = icr; // valeur maximale du compteur
  TCNT1 = 0; // mise à zéro du compteur
  TCCR1B |= d; // déclenchement du compteur
}

void rapport_cyclique(float r) {
  OCR1A = icr*r;
}

void definir_signal(float amp) { // amplitude inférieure à 1
  for (int i=0; i<NE; i++) echant[i] = 0.5*(1+amp*sin(2*PI/NE*i));
}

void setup() {
  Serial.begin(9600);
  pinMode(SORTIE,OUTPUT);
  period = 1000; // période de la porteuse en microsecondes
  init_pwm_timer1(period);
  definir_signal(0.5);
  periode_echant = 10000;// microsecondes
  indice = 0;
}

void loop() {
  delayMicroseconds(periode_echant);
  indice += 1;
  if (indice==NE) indice=0;
  rapport_cyclique(echant[indice]);

}
        		 
