
#define SORTIE 11
#define ENTREE A0


uint32_t icr;
uint32_t period;
uint32_t periode_echant;


//Initialisation du Timer1 pour génération MLI
void init_pwm_timer1(uint32_t period) { // période en microsecondes
  uint16_t diviseur[6] = {0,1,8,64,256,1024};
  TCCR1A = (1 << COM1A1); //Clear OC1A on compare match when upcounting, set OC1A on compare match when downcounting
  TCCR1B = 1 << WGM13; // phase and frequency correct pwm mode, top = ICR1
  int d=1;
  icr = (F_CPU/1000000*period/2);
  while ((icr>0xFFFF)&&(d<6)) { // choix du diviseur d'horloge
     d++;
     icr = (F_CPU/1000000*period/2/diviseur[d]);
  }
  Serial.print("diviseur_1= "); Serial.println(d);
  Serial.print("icr_1 = "); Serial.println(icr);
  float periode_effective = icr*2*d*1000000.0/F_CPU;
  Serial.print("periode_1 (us) = "); Serial.println(periode_effective);
  ICR1 = icr; // valeur maximale du compteur
  TIMSK1 = 1 << TOIE1; // overflow interrupt enable
  TCNT1 = 0; // mise à zéro du compteur
  TCCR1B |= d; // déclenchement du compteur
}


//Fonction appelée à l'interruption //
ISR(TIMER1_OVF_vect) { // Timer 3 Overflow interrupt
  ADMUX = 0b01000000 | 0; // voie A0
  ADCSRA |= 0b01000000; // start ADC
  while (ADCSRA & 0b01000000);
  
  OCR1A = icr* (ADCL | (ADCH << 8))/1023.0;
}


void adc_init(uint8_t prescaler) {
  ADCSRA = 0;
  ADCSRA |= (1 << ADEN); // enable ADC
  ADCSRA |= prescaler ;
  ADCSRB = 0;
}

void setup() {
  Serial.begin(9600);
  pinMode(SORTIE,OUTPUT);
  period = 500; // période de la porteuse en microsecondes
  init_pwm_timer1(period);
  adc_init(4);
}

void loop() {

}       		  
        		  
